<template>
    <div>
        <MdField v-bind:class="{'md-invalid': emptyAndRequired }">
            <label>{{field.label}}</label>
            <MdTextarea
                    v-if="field.type === 'textarea'"
                    :placeholder="field.placeholder"
                    md-autogrow
                    :required="field.required"
                    v-model="model"
            />
            <MdInput
                    v-else
                    :placeholder="field.placeholder"
                    :required="field.required"
                    v-model="model"
                    :type="field.type"
            />
            <span class="md-error">{{$t('editor.requiredField')}}</span>
        </MdField>
    </div>
</template>
<script>
  import Vue from 'vue';

  import { MdField, MdTextArea } from 'vue-material/dist/components';

  Vue.use(MdField);

  export default {
    props: {
      values: {
        type: Object,
        isRequired: true
      },
      field: {
        type: Object,
        isRequired: true
      }
    },
    data(){
      return {
        emptyAndRequired: false
      }
    },
    computed: {
      model: {
        get(){
          return this.values && this.values[this.field.key];
        },
        set(value){
          this.values[this.field.key] = value;
          this.emptyAndRequired = this.field.required && (!value || value.trim().length === 0);
          this.$emit('edited', {key: this.field.key, value});
        }
      }
    }
  };
</script>
<style scoped>

</style>
